//suhas.t.nagar@gmail.com
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;

public class suhas {
    public static class CombinatoricsModM {
        private static long[] fact;
        private static long[] invFact;
        public static int mod;

        public CombinatoricsModM(int maxN, int m) {
            mod = m;
            fact = new long[maxN + 1];
            invFact = new long[maxN + 1];
            precomputeFactorials(maxN);
        }
        private void precomputeFactorials(int maxN) {
            fact[0] = 1;
            for (int i = 1; i <= maxN; i++) {
                fact[i] = (fact[i - 1] * i) % mod;
            }

            invFact[maxN] = modInverse(fact[maxN], mod);
            for (int i = maxN - 1; i >= 0; i--) {
                invFact[i] = (invFact[i + 1] * (i + 1)) % mod;
            }
        }
        private long modInverse(long a, int m) {
            long modinv = extendedGCD(a, m)[0] % m;
            return (modinv+m)%m;
        }
        private long[] extendedGCD(long a, long b) {
            if (b == 0) return new long[]{1, 0, a};
            long[] res = extendedGCD(b, a % b);
            return new long[]{res[1], res[0] - (a / b) * res[1], res[2]};
        }
        public long binomialCoefficient(int n, int k) {
            if (k < 0 || k > n) return 0;
            return (fact[n] * invFact[k] % mod) * invFact[n - k] % mod;
        }
        public long invbinomialCoefficient(int n, int k) {
            if (k < 0 || k > n) return 0;
            return (invFact[n] * fact[k] % mod) * fact[n - k] % mod;
        }
    }
    static long MOD = 998244353;

    static int mapC(char c){
        if (c == 'B') return 0;
        if (c == 'Y') return 1;
        return 2;
    }
    static class Poly{
        long[] arr;
        public Poly(long[] arr){
            this.arr = arr;
        }
        public Poly(int n){
            this.arr = new long[n];
        }
        public void add(Poly p){
            if (p.arr.length > arr.length){
                long[] reinit = new long[p.arr.length];
                for (int i = 0; i < arr.length; i++){
                    reinit[i] = arr[i];
                }
                arr = reinit;
            }
            for (int i = 0; i < p.arr.length; i++){
                arr[i] += p.arr[i];
                arr[i] %= MOD;
            }
        }
    }
    static int[] arr;
    public static Poly[] dnc(int l, int r){
        Poly[] ret = new Poly[6];
        for (int i = 0; i < 6; i++){
            ret[i] = new Poly(1);
        }
        if (r < l) return ret;
        int mid = (l+r)/2;
        if (r == l){
            long[] set = new long[]{0,1};
            ret[arr[mid]] = new Poly(set);
            return ret;
        }

        Poly[] left = dnc(l,mid);
        Poly[] right = dnc(mid+1,r);
        // any solution to subpart is valid for current
        for (int i = 0; i < 6; i++){
            ret[i].add(left[i]);
            ret[i].add(right[i]);
        }
        // 1 <> 1 to get 1
        ret[0].add(new Poly(NTT.NTT4.convolution(left[0].arr,right[0].arr)));
        // 1 <> 2,12 to get 12
        Poly r12 = new Poly(right[3].arr);
        r12.add(right[1]);
        ret[3].add(new Poly(NTT.NTT4.convolution(left[0].arr,r12.arr)));
        // 1 <> 3,23,123 to get 123
        Poly p = new Poly(right[5].arr);
        p.add(right[4]);
        p.add(right[2]);
        ret[5].add(new Poly(NTT.NTT4.convolution(left[0].arr,p.arr)));

        Poly r23 = new Poly(right[4].arr);
        r23.add(right[2]);
        // 12 <> 3,23 to get 123
        ret[5].add(new Poly(NTT.NTT4.convolution(left[3].arr,r23.arr)));
        // 2 <> 3,23 to get 23
        ret[4].add(new Poly(NTT.NTT4.convolution(left[1].arr,r23.arr)));
        // 12 <> 2 to get 12
        ret[3].add(new Poly(NTT.NTT4.convolution(left[3].arr,right[1].arr)));
        // 2  <> 2 to get 2
        ret[1].add(new Poly(NTT.NTT4.convolution(left[1].arr,right[1].arr)));
        // 123 <> 3 to get 123
        ret[5].add(new Poly(NTT.NTT4.convolution(left[5].arr,right[2].arr)));
        // 23  <> 3 to get 23
        ret[4].add(new Poly(NTT.NTT4.convolution(left[4].arr,right[2].arr)));
        // 3  <> 3 to get 3
        ret[2].add(new Poly(NTT.NTT4.convolution(left[2].arr,right[2].arr)));
        return ret;
    }

    static boolean isSorted(int[] arr){
        for (int i = 1; i < arr.length; i++){
            if (arr[i] < arr[i-1]) return false;
        }
        return true;
    }
    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        String s = br.readLine();
        int n = s.length();
        arr = new int[n];
        for (int i = 0; i < n; i++){
            arr[i] = mapC(s.charAt(i));
        }
        Poly[] ps = dnc(0,n-1);
        for (int i = 1; i < 6; i++){
            ps[0].add(ps[i]);
        }
        ps[0].add(new Poly(n));
        ps[0].arr[0] += isSorted(arr) ? 1 : 0;
        long ret = 0;
        CombinatoricsModM cmm = new CombinatoricsModM(200005, (int) MOD);
        for (int i = 0; i < n; i++){
            // ps[0].arr[i] is number increasing of length i
            // after i seconds, n choose i sequences are possible, only above work
            // will always reach an extra second if i am at n choose i - working
            long v = cmm.binomialCoefficient(n,i)-ps[0].arr[i];
            v = (v+MOD)%MOD;
            v = v * cmm.invbinomialCoefficient(n,i);
            v %= MOD;
            ret += v;
            ret %= MOD;
        }
        System.out.println(ret);

    }
}

class NTT {
    private final long MOD;
    private final Mods MA;
    private final long PRIMITIVE_ROOT;
    private NTT(Mods ma, long primitiveRoot) {
        this.MOD = ma.MOD;
        this.MA = ma;
        this.PRIMITIVE_ROOT = primitiveRoot;
    }

    private void ntt(long[] a, int sign) {
        int n = a.length;
        long h = MA.pow(PRIMITIVE_ROOT, MA.mul((MOD - 1), MA.inv(n))); // ^n√g
        if (sign == -1) h = MA.inv(h);
        int i = 0;
        for (int j = 1; j < n - 1; j++) {
            for (int k = n >> 1; k > (i ^= k); k >>= 1);
            if (j < i) {long tmp = a[i]; a[i] = a[j]; a[j] = tmp;}
        }
        for (int m = 1; m < n; m <<= 1) {
            int m2 = m << 1;
            long base = MA.pow(h, n / m2);
            long w = 1;
            for (int x = 0; x < m; x++) {
                for (int s = x; s < n; s += m2) {
                    long u = a[s];
                    long d = MA.mul(a[s + m], w);
                    a[s] = MA.add(u, d);
                    a[s+m] = MA.sub(u, d);
                }
                w = MA.mul(w, base);
            }
        }
    }

    private void ntt(long[] input) {
        ntt(input, 1);
    }

    private void intt(long[] input) {
        ntt(input, -1);
        int l = input.length;
        long inv = MA.inv(l);
        for (int i = 0; i < l; i++) {
            input[i] = MA.mul(input[i], inv);
        }
    }

    public long[] convolution(long[] a, long[] b){
        int result_size = a.length + b.length - 1;
        int n = 1; while (n < result_size) n <<= 1;
        long[] aa = new long[n];
        long[] bb = new long[n];
        System.arraycopy(a, 0, aa, 0, a.length);
        System.arraycopy(b, 0, bb, 0, b.length);
        ntt(aa);
        ntt(bb);
        for (int i=0; i<n; ++i) aa[i] = (aa[i] * bb[i]) % MOD;
        intt(aa);
        long[] ret = new long[result_size];
        System.arraycopy(aa, 0, ret, 0, result_size);
        return ret;
    }

    public static final long MOD4 = 998244353;
    public static final NTT NTT4 = new NTT(new Mods(MOD4), 3);
}

class Mods {
    public final long MOD;
    public Mods(final long p) {this.MOD = p;}
    public static long inv(long a, final long mod) {
        long b = mod;
        long u = 1, v = 0;
        while (b >= 1) {
            final long t = a / b;
            a -= t * b;
            final long tmp1 = a; a = b; b = tmp1;
            u -= t * v;
            final long tmp2 = u; u = v; v = tmp2;
        }
        u %= mod;
        return u < 0 ? u + mod : u;
    }
    public long mod(long a) {a %= MOD; return a < 0 ? a + MOD : a;}
    public long add(final long a, final long b) {
        final long s = a + b;
        return s < 0 ? s + MOD : s >= MOD ? s - MOD : s;
    }
    public long mul(final long a, final long b) {
        final long s = (a * b) % MOD;
        return s < 0 ? s + MOD : s;
    }
    public long sub(final long a, final long b) {
        final long s = a - b;
        return s < 0 ? s + MOD : s >= MOD ? s - MOD : s;
    }
    public long prod(final long... a) {
        long ret = 1;
        for (final long c : a) ret = (ret * c) % MOD;
        return ret < 0 ? ret + MOD : ret;
    }
    public long inv(long a) {
        long b = MOD;
        long u = 1, v = 0;
        while (b >= 1) {
            final long t = a / b;
            a -= t * b;
            final long tmp1 = a; a = b; b = tmp1;
            u -= t * v;
            final long tmp2 = u; u = v; v = tmp2;
        }
        return mod(u);
    }
    public long pow(final long a, final long b) {
        if (b == 0 || a == 1) return 1;
        final long half = pow(a, b >> 1);
        return (b & 1) == 0 ? mul(half, half) : prod(half, half, a);
    }
}
class Garner {
    public static long garner(long[] xs, long[] mods) {
        int n = xs.length;
        long[] cnst = new long[n];
        long[] coef = new long[n];
        Arrays.fill(coef, 1);
        for (int i = 0; i < n - 1; i++) {
            long m1 = mods[i];
            long v = (xs[i] - cnst[i] + m1) % m1;
            v = (v * Mods.inv(coef[i], m1)) % m1;
            for (int j = i + 1; j < n; j++) {
                long m2 = mods[j];
                cnst[j] = (cnst[j] + coef[j] * v) % m2;
                coef[j] = (coef[j] * m1) % m2;
            }
        }
        return cnst[n - 1];
    }
}
